window.ByteBuffer = function(h) {
    "use strict";
    var w = function(e, t, i) {
        if (typeof e === "undefined") e = w.DEFAULT_CAPACITY;
        if (typeof t === "undefined") t = w.DEFAULT_ENDIAN;
        if (typeof i === "undefined") i = w.DEFAULT_NOASSERT;
        if (!i) {
            e = e | 0;
            if (e < 0) throw RangeError("Illegal capacity");
            t = !!t;
            i = !!i;
        }
        this.buffer = e === 0 ? n : new ArrayBuffer(e);
        this.view = e === 0 ? null : new Uint8Array(this.buffer);
        this.offset = 0;
        this.markedOffset = -1;
        this.limit = e;
        this.littleEndian = t;
        this.noAssert = i;
    };
    w.VERSION = "5.0.1", w.LITTLE_ENDIAN = true, w.BIG_ENDIAN = false, w.DEFAULT_CAPACITY = 16,
        w.DEFAULT_ENDIAN = w.BIG_ENDIAN, w.DEFAULT_NOASSERT = false, w.Long = h || null;
    var s = w.prototype;
    s.__isByteBuffer__, Object.defineProperty(s, "__isByteBuffer__", {
        value: true,
        enumerable: false,
        configurable: false
    });
    var n = new ArrayBuffer(0),
        i = String.fromCharCode;

    function o(e) {
        var t = 0;
        return function() {
            return t < e.length ? e.charCodeAt(t++) : null;
        };
    }

    function a() {
        var e = [],
            t = [];
        return function() {
            if (arguments.length === 0) return t.join("") + i.apply(String, e);
            if (e.length + arguments.length > 1024) t.push(i.apply(String, e)), e.length = 0;
            Array.prototype.push.apply(e, arguments);
        };
    }
    if (w.accessor = function() {
            return Uint8Array;
        }, w.allocate = function(e, t, i) {
            return new w(e, t, i);
        }, w.concat = function(e, t, i, r) {
            if (typeof t === "boolean" || typeof t !== "string") {
                r = i;
                i = t;
                t = undefined;
            }
            var f = 0;
            for (var n = 0, s = e.length, o; n < s; ++n) {
                if (!w.isByteBuffer(e[n])) e[n] = w.wrap(e[n], t);
                o = e[n].limit - e[n].offset;
                if (o > 0) f += o;
            }
            if (f === 0) return new w(0, i, r);
            var h = new w(f, i, r),
                a;
            n = 0;
            while (n < s) {
                a = e[n++];
                o = a.limit - a.offset;
                if (o <= 0) continue;
                h.view.set(a.view.subarray(a.offset, a.limit), h.offset);
                h.offset += o;
            }
            h.limit = h.offset;
            h.offset = 0;
            return h;
        }, w.isByteBuffer = function(e) {
            return (e && e["__isByteBuffer__"]) === true;
        }, w.type = function() {
            return ArrayBuffer;
        }, w.wrap = function(e, t, i, r) {
            if (typeof t !== "string") {
                r = i;
                i = t;
                t = undefined;
            }
            if (typeof e === "string") {
                if (typeof t === "undefined") t = "utf8";
                switch (t) {
                    case "base64":
                        return w.fromBase64(e, i);

                    case "hex":
                        return w.fromHex(e, i);

                    case "binary":
                        return w.fromBinary(e, i);

                    case "utf8":
                        return w.fromUTF8(e, i);

                    case "debug":
                        return w.fromDebug(e, i);

                    default:
                        throw Error("Unsupported encoding: " + t);
                }
            }
            if (e === null || typeof e !== "object") throw TypeError("Illegal buffer");
            var f;
            if (w.isByteBuffer(e)) {
                f = s.clone.call(e);
                f.markedOffset = -1;
                return f;
            }
            if (e instanceof Uint8Array) {
                f = new w(0, i, r);
                if (e.length > 0) {
                    f.buffer = e.buffer;
                    f.offset = e.byteOffset;
                    f.limit = e.byteOffset + e.byteLength;
                    f.view = new Uint8Array(e.buffer);
                }
            } else if (e instanceof ArrayBuffer) {
                f = new w(0, i, r);
                if (e.byteLength > 0) {
                    f.buffer = e;
                    f.offset = 0;
                    f.limit = e.byteLength;
                    f.view = e.byteLength > 0 ? new Uint8Array(e) : null;
                }
            } else if (Object.prototype.toString.call(e) === "[object Array]") {
                f = new w(e.length, i, r);
                f.limit = e.length;
                for (var n = 0; n < e.length; ++n) f.view[n] = e[n];
            } else throw TypeError("Illegal buffer");
            return f;
        }, s.writeBitSet = function(e, t) {
            var i = typeof t === "undefined";
            if (i) t = this.offset;
            if (!this.noAssert) {
                if (!(e instanceof Array)) throw TypeError("Illegal BitSet: Not an array");
                if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
                t >>>= 0;
                if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
            }
            var r = t,
                f = e.length,
                n = f >> 3,
                s = 0,
                o;
            t += this.writeVarint32(f, t);
            while (n--) {
                o = !!e[s++] & 1 | (!!e[s++] & 1) << 1 | (!!e[s++] & 1) << 2 | (!!e[s++] & 1) << 3 | (!!e[s++] & 1) << 4 | (!!e[s++] & 1) << 5 | (!!e[s++] & 1) << 6 | (!!e[s++] & 1) << 7;
                this.writeByte(o, t++);
            }
            if (s < f) {
                var h = 0;
                o = 0;
                while (s < f) o = o | (!!e[s++] & 1) << h++;
                this.writeByte(o, t++);
            }
            if (i) {
                this.offset = t;
                return this;
            }
            return t - r;
        }, s.readBitSet = function(e) {
            var t = typeof e === "undefined";
            if (t) e = this.offset;
            var i = this.readVarint32(e),
                r = i.value,
                f = r >> 3,
                n = 0,
                s = [],
                o;
            e += i.length;
            while (f--) {
                o = this.readByte(e++);
                s[n++] = !!(o & 1);
                s[n++] = !!(o & 2);
                s[n++] = !!(o & 4);
                s[n++] = !!(o & 8);
                s[n++] = !!(o & 16);
                s[n++] = !!(o & 32);
                s[n++] = !!(o & 64);
                s[n++] = !!(o & 128);
            }
            if (n < r) {
                var h = 0;
                o = this.readByte(e++);
                while (n < r) s[n++] = !!(o >> h++ & 1);
            }
            if (t) {
                this.offset = e;
            }
            return s;
        }, s.readBytes = function(e, t) {
            var i = typeof t === "undefined";
            if (i) t = this.offset;
            if (!this.noAssert) {
                if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
                t >>>= 0;
                if (t < 0 || t + e > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + e + ") <= " + this.buffer.byteLength);
            }
            var r = this.slice(t, t + e);
            if (i) this.offset += e;
            return r;
        }, s.writeInt8 = function(e, t) {
            var i = typeof t === "undefined";
            if (i) t = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal value: " + e + " (not an integer)");
                e |= 0;
                if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
                t >>>= 0;
                if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
            }
            t += 1;
            var r = this.buffer.byteLength;
            if (t > r) this.resize((r *= 2) > t ? r : t);
            t -= 1;
            this.view[t] = e;
            if (i) this.offset += 1;
            return this;
        }, s.writeByte = s.writeInt8, s.readInt8 = function(e) {
            var t = typeof e === "undefined";
            if (t) e = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal offset: " + e + " (not an integer)");
                e >>>= 0;
                if (e < 0 || e + 1 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + e + " (+" + 1 + ") <= " + this.buffer.byteLength);
            }
            var i = this.view[e];
            if ((i & 128) === 128) i = -(255 - i + 1);
            if (t) this.offset += 1;
            return i;
        }, s.readByte = s.readInt8, s.writeUint8 = function(e, t) {
            var i = typeof t === "undefined";
            if (i) t = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal value: " + e + " (not an integer)");
                e >>>= 0;
                if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
                t >>>= 0;
                if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
            }
            t += 1;
            var r = this.buffer.byteLength;
            if (t > r) this.resize((r *= 2) > t ? r : t);
            t -= 1;
            this.view[t] = e;
            if (i) this.offset += 1;
            return this;
        }, s.writeUInt8 = s.writeUint8, s.readUint8 = function(e) {
            var t = typeof e === "undefined";
            if (t) e = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal offset: " + e + " (not an integer)");
                e >>>= 0;
                if (e < 0 || e + 1 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + e + " (+" + 1 + ") <= " + this.buffer.byteLength);
            }
            var i = this.view[e];
            if (t) this.offset += 1;
            return i;
        }, s.readUInt8 = s.readUint8, s.writeInt16 = function(e, t) {
            var i = typeof t === "undefined";
            if (i) t = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal value: " + e + " (not an integer)");
                e |= 0;
                if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
                t >>>= 0;
                if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
            }
            t += 2;
            var r = this.buffer.byteLength;
            if (t > r) this.resize((r *= 2) > t ? r : t);
            t -= 2;
            if (this.littleEndian) {
                this.view[t + 1] = (e & 65280) >>> 8;
                this.view[t] = e & 255;
            } else {
                this.view[t] = (e & 65280) >>> 8;
                this.view[t + 1] = e & 255;
            }
            if (i) this.offset += 2;
            return this;
        }, s.writeShort = s.writeInt16, s.readInt16 = function(e) {
            var t = typeof e === "undefined";
            if (t) e = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal offset: " + e + " (not an integer)");
                e >>>= 0;
                if (e < 0 || e + 2 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + e + " (+" + 2 + ") <= " + this.buffer.byteLength);
            }
            var i = 0;
            if (this.littleEndian) {
                i = this.view[e];
                i |= this.view[e + 1] << 8;
            } else {
                i = this.view[e] << 8;
                i |= this.view[e + 1];
            }
            if ((i & 32768) === 32768) i = -(65535 - i + 1);
            if (t) this.offset += 2;
            return i;
        }, s.readShort = s.readInt16, s.writeUint16 = function(e, t) {
            var i = typeof t === "undefined";
            if (i) t = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal value: " + e + " (not an integer)");
                e >>>= 0;
                if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
                t >>>= 0;
                if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
            }
            t += 2;
            var r = this.buffer.byteLength;
            if (t > r) this.resize((r *= 2) > t ? r : t);
            t -= 2;
            if (this.littleEndian) {
                this.view[t + 1] = (e & 65280) >>> 8;
                this.view[t] = e & 255;
            } else {
                this.view[t] = (e & 65280) >>> 8;
                this.view[t + 1] = e & 255;
            }
            if (i) this.offset += 2;
            return this;
        }, s.writeUInt16 = s.writeUint16, s.readUint16 = function(e) {
            var t = typeof e === "undefined";
            if (t) e = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal offset: " + e + " (not an integer)");
                e >>>= 0;
                if (e < 0 || e + 2 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + e + " (+" + 2 + ") <= " + this.buffer.byteLength);
            }
            var i = 0;
            if (this.littleEndian) {
                i = this.view[e];
                i |= this.view[e + 1] << 8;
            } else {
                i = this.view[e] << 8;
                i |= this.view[e + 1];
            }
            if (t) this.offset += 2;
            return i;
        }, s.readUInt16 = s.readUint16, s.writeInt32 = function(e, t) {
            var i = typeof t === "undefined";
            if (i) t = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal value: " + e + " (not an integer)");
                e |= 0;
                if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
                t >>>= 0;
                if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
            }
            t += 4;
            var r = this.buffer.byteLength;
            if (t > r) this.resize((r *= 2) > t ? r : t);
            t -= 4;
            if (this.littleEndian) {
                this.view[t + 3] = e >>> 24 & 255;
                this.view[t + 2] = e >>> 16 & 255;
                this.view[t + 1] = e >>> 8 & 255;
                this.view[t] = e & 255;
            } else {
                this.view[t] = e >>> 24 & 255;
                this.view[t + 1] = e >>> 16 & 255;
                this.view[t + 2] = e >>> 8 & 255;
                this.view[t + 3] = e & 255;
            }
            if (i) this.offset += 4;
            return this;
        }, s.writeInt = s.writeInt32, s.readInt32 = function(e) {
            var t = typeof e === "undefined";
            if (t) e = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal offset: " + e + " (not an integer)");
                e >>>= 0;
                if (e < 0 || e + 4 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + e + " (+" + 4 + ") <= " + this.buffer.byteLength);
            }
            var i = 0;
            if (this.littleEndian) {
                i = this.view[e + 2] << 16;
                i |= this.view[e + 1] << 8;
                i |= this.view[e];
                i += this.view[e + 3] << 24 >>> 0;
            } else {
                i = this.view[e + 1] << 16;
                i |= this.view[e + 2] << 8;
                i |= this.view[e + 3];
                i += this.view[e] << 24 >>> 0;
            }
            i |= 0;
            if (t) this.offset += 4;
            return i;
        }, s.readInt = s.readInt32, s.writeUint32 = function(e, t) {
            var i = typeof t === "undefined";
            if (i) t = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal value: " + e + " (not an integer)");
                e >>>= 0;
                if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
                t >>>= 0;
                if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
            }
            t += 4;
            var r = this.buffer.byteLength;
            if (t > r) this.resize((r *= 2) > t ? r : t);
            t -= 4;
            if (this.littleEndian) {
                this.view[t + 3] = e >>> 24 & 255;
                this.view[t + 2] = e >>> 16 & 255;
                this.view[t + 1] = e >>> 8 & 255;
                this.view[t] = e & 255;
            } else {
                this.view[t] = e >>> 24 & 255;
                this.view[t + 1] = e >>> 16 & 255;
                this.view[t + 2] = e >>> 8 & 255;
                this.view[t + 3] = e & 255;
            }
            if (i) this.offset += 4;
            return this;
        }, s.writeUInt32 = s.writeUint32, s.readUint32 = function(e) {
            var t = typeof e === "undefined";
            if (t) e = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal offset: " + e + " (not an integer)");
                e >>>= 0;
                if (e < 0 || e + 4 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + e + " (+" + 4 + ") <= " + this.buffer.byteLength);
            }
            var i = 0;
            if (this.littleEndian) {
                i = this.view[e + 2] << 16;
                i |= this.view[e + 1] << 8;
                i |= this.view[e];
                i += this.view[e + 3] << 24 >>> 0;
            } else {
                i = this.view[e + 1] << 16;
                i |= this.view[e + 2] << 8;
                i |= this.view[e + 3];
                i += this.view[e] << 24 >>> 0;
            }
            if (t) this.offset += 4;
            return i;
        }, s.readUInt32 = s.readUint32, h) {
        s.writeInt64 = function(e, t) {
            var i = typeof t === "undefined";
            if (i) t = this.offset;
            if (!this.noAssert) {
                if (typeof e === "number") e = h.fromNumber(e);
                else if (typeof e === "string") e = h.fromString(e);
                else if (!(e && e instanceof h)) throw TypeError("Illegal value: " + e + " (not an integer or Long)");
                if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
                t >>>= 0;
                if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
            }
            if (typeof e === "number") e = h.fromNumber(e);
            else if (typeof e === "string") e = h.fromString(e);
            t += 8;
            var r = this.buffer.byteLength;
            if (t > r) this.resize((r *= 2) > t ? r : t);
            t -= 8;
            var f = e.low,
                n = e.high;
            if (this.littleEndian) {
                this.view[t + 3] = f >>> 24 & 255;
                this.view[t + 2] = f >>> 16 & 255;
                this.view[t + 1] = f >>> 8 & 255;
                this.view[t] = f & 255;
                t += 4;
                this.view[t + 3] = n >>> 24 & 255;
                this.view[t + 2] = n >>> 16 & 255;
                this.view[t + 1] = n >>> 8 & 255;
                this.view[t] = n & 255;
            } else {
                this.view[t] = n >>> 24 & 255;
                this.view[t + 1] = n >>> 16 & 255;
                this.view[t + 2] = n >>> 8 & 255;
                this.view[t + 3] = n & 255;
                t += 4;
                this.view[t] = f >>> 24 & 255;
                this.view[t + 1] = f >>> 16 & 255;
                this.view[t + 2] = f >>> 8 & 255;
                this.view[t + 3] = f & 255;
            }
            if (i) this.offset += 8;
            return this;
        };
        s.writeLong = s.writeInt64;
        s.readInt64 = function(e) {
            var t = typeof e === "undefined";
            if (t) e = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal offset: " + e + " (not an integer)");
                e >>>= 0;
                if (e < 0 || e + 8 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + e + " (+" + 8 + ") <= " + this.buffer.byteLength);
            }
            var i = 0,
                r = 0;
            if (this.littleEndian) {
                i = this.view[e + 2] << 16;
                i |= this.view[e + 1] << 8;
                i |= this.view[e];
                i += this.view[e + 3] << 24 >>> 0;
                e += 4;
                r = this.view[e + 2] << 16;
                r |= this.view[e + 1] << 8;
                r |= this.view[e];
                r += this.view[e + 3] << 24 >>> 0;
            } else {
                r = this.view[e + 1] << 16;
                r |= this.view[e + 2] << 8;
                r |= this.view[e + 3];
                r += this.view[e] << 24 >>> 0;
                e += 4;
                i = this.view[e + 1] << 16;
                i |= this.view[e + 2] << 8;
                i |= this.view[e + 3];
                i += this.view[e] << 24 >>> 0;
            }
            var f = new h(i, r, false);
            if (t) this.offset += 8;
            return f;
        };
        s.readLong = s.readInt64;
        s.writeUint64 = function(e, t) {
            var i = typeof t === "undefined";
            if (i) t = this.offset;
            if (!this.noAssert) {
                if (typeof e === "number") e = h.fromNumber(e);
                else if (typeof e === "string") e = h.fromString(e);
                else if (!(e && e instanceof h)) throw TypeError("Illegal value: " + e + " (not an integer or Long)");
                if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
                t >>>= 0;
                if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
            }
            if (typeof e === "number") e = h.fromNumber(e);
            else if (typeof e === "string") e = h.fromString(e);
            t += 8;
            var r = this.buffer.byteLength;
            if (t > r) this.resize((r *= 2) > t ? r : t);
            t -= 8;
            var f = e.low,
                n = e.high;
            if (this.littleEndian) {
                this.view[t + 3] = f >>> 24 & 255;
                this.view[t + 2] = f >>> 16 & 255;
                this.view[t + 1] = f >>> 8 & 255;
                this.view[t] = f & 255;
                t += 4;
                this.view[t + 3] = n >>> 24 & 255;
                this.view[t + 2] = n >>> 16 & 255;
                this.view[t + 1] = n >>> 8 & 255;
                this.view[t] = n & 255;
            } else {
                this.view[t] = n >>> 24 & 255;
                this.view[t + 1] = n >>> 16 & 255;
                this.view[t + 2] = n >>> 8 & 255;
                this.view[t + 3] = n & 255;
                t += 4;
                this.view[t] = f >>> 24 & 255;
                this.view[t + 1] = f >>> 16 & 255;
                this.view[t + 2] = f >>> 8 & 255;
                this.view[t + 3] = f & 255;
            }
            if (i) this.offset += 8;
            return this;
        };
        s.writeUInt64 = s.writeUint64;
        s.readUint64 = function(e) {
            var t = typeof e === "undefined";
            if (t) e = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal offset: " + e + " (not an integer)");
                e >>>= 0;
                if (e < 0 || e + 8 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + e + " (+" + 8 + ") <= " + this.buffer.byteLength);
            }
            var i = 0,
                r = 0;
            if (this.littleEndian) {
                i = this.view[e + 2] << 16;
                i |= this.view[e + 1] << 8;
                i |= this.view[e];
                i += this.view[e + 3] << 24 >>> 0;
                e += 4;
                r = this.view[e + 2] << 16;
                r |= this.view[e + 1] << 8;
                r |= this.view[e];
                r += this.view[e + 3] << 24 >>> 0;
            } else {
                r = this.view[e + 1] << 16;
                r |= this.view[e + 2] << 8;
                r |= this.view[e + 3];
                r += this.view[e] << 24 >>> 0;
                e += 4;
                i = this.view[e + 1] << 16;
                i |= this.view[e + 2] << 8;
                i |= this.view[e + 3];
                i += this.view[e] << 24 >>> 0;
            }
            var f = new h(i, r, true);
            if (t) this.offset += 8;
            return f;
        };
        s.readUInt64 = s.readUint64;
    }

    function r(e, t, i, r, f) {
        var n, s, o = f * 8 - r - 1,
            h = (1 << o) - 1,
            a = h >> 1,
            l = -7,
            u = i ? f - 1 : 0,
            g = i ? -1 : 1,
            y = e[t + u];
        u += g;
        n = y & (1 << -l) - 1;
        y >>= -l;
        l += o;
        for (; l > 0; n = n * 256 + e[t + u], u += g, l -= 8) {}
        s = n & (1 << -l) - 1;
        n >>= -l;
        l += r;
        for (; l > 0; s = s * 256 + e[t + u], u += g, l -= 8) {}
        if (n === 0) {
            n = 1 - a;
        } else if (n === h) {
            return s ? NaN : (y ? -1 : 1) * Infinity;
        } else {
            s = s + Math.pow(2, r);
            n = n - a;
        }
        return (y ? -1 : 1) * s * Math.pow(2, n - r);
    }

    function f(e, t, i, r, f, n) {
        var s, o, h, a = n * 8 - f - 1,
            l = (1 << a) - 1,
            u = l >> 1,
            g = f === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0,
            y = r ? 0 : n - 1,
            w = r ? 1 : -1,
            b = t < 0 || t === 0 && 1 / t < 0 ? 1 : 0;
        t = Math.abs(t);
        if (isNaN(t) || t === Infinity) {
            o = isNaN(t) ? 1 : 0;
            s = l;
        } else {
            s = Math.floor(Math.log(t) / Math.LN2);
            if (t * (h = Math.pow(2, -s)) < 1) {
                s--;
                h *= 2;
            }
            if (s + u >= 1) {
                t += g / h;
            } else {
                t += g * Math.pow(2, 1 - u);
            }
            if (t * h >= 2) {
                s++;
                h /= 2;
            }
            if (s + u >= l) {
                o = 0;
                s = l;
            } else if (s + u >= 1) {
                o = (t * h - 1) * Math.pow(2, f);
                s = s + u;
            } else {
                o = t * Math.pow(2, u - 1) * Math.pow(2, f);
                s = 0;
            }
        }
        for (; f >= 8; e[i + y] = o & 255, y += w, o /= 256, f -= 8) {}
        s = s << f | o;
        a += f;
        for (; a > 0; e[i + y] = s & 255, y += w, s /= 256, a -= 8) {}
        e[i + y - w] |= b * 128;
    }
    if (s.writeFloat32 = function(e, t) {
            var i = typeof t === "undefined";
            if (i) t = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number") throw TypeError("Illegal value: " + e + " (not a number)");
                if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
                t >>>= 0;
                if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
            }
            t += 4;
            var r = this.buffer.byteLength;
            if (t > r) this.resize((r *= 2) > t ? r : t);
            t -= 4;
            f(this.view, e, t, this.littleEndian, 23, 4);
            if (i) this.offset += 4;
            return this;
        }, s.writeFloat = s.writeFloat32, s.readFloat32 = function(e) {
            var t = typeof e === "undefined";
            if (t) e = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal offset: " + e + " (not an integer)");
                e >>>= 0;
                if (e < 0 || e + 4 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + e + " (+" + 4 + ") <= " + this.buffer.byteLength);
            }
            var i = r(this.view, e, this.littleEndian, 23, 4);
            if (t) this.offset += 4;
            return i;
        }, s.readFloat = s.readFloat32, s.writeFloat64 = function(e, t) {
            var i = typeof t === "undefined";
            if (i) t = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number") throw TypeError("Illegal value: " + e + " (not a number)");
                if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
                t >>>= 0;
                if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
            }
            t += 8;
            var r = this.buffer.byteLength;
            if (t > r) this.resize((r *= 2) > t ? r : t);
            t -= 8;
            f(this.view, e, t, this.littleEndian, 52, 8);
            if (i) this.offset += 8;
            return this;
        }, s.writeDouble = s.writeFloat64, s.readFloat64 = function(e) {
            var t = typeof e === "undefined";
            if (t) e = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal offset: " + e + " (not an integer)");
                e >>>= 0;
                if (e < 0 || e + 8 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + e + " (+" + 8 + ") <= " + this.buffer.byteLength);
            }
            var i = r(this.view, e, this.littleEndian, 52, 8);
            if (t) this.offset += 8;
            return i;
        }, s.readDouble = s.readFloat64, w.MAX_VARINT32_BYTES = 5, w.calculateVarint32 = function(e) {
            e = e >>> 0;
            if (e < 1 << 7) return 1;
            else if (e < 1 << 14) return 2;
            else if (e < 1 << 21) return 3;
            else if (e < 1 << 28) return 4;
            else return 5;
        }, w.zigZagEncode32 = function(e) {
            return ((e |= 0) << 1 ^ e >> 31) >>> 0;
        }, w.zigZagDecode32 = function(e) {
            return e >>> 1 ^ -(e & 1) | 0;
        }, s.writeVarint32 = function(e, t) {
            var i = typeof t === "undefined";
            if (i) t = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal value: " + e + " (not an integer)");
                e |= 0;
                if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
                t >>>= 0;
                if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
            }
            var r = w.calculateVarint32(e),
                f;
            t += r;
            var n = this.buffer.byteLength;
            if (t > n) this.resize((n *= 2) > t ? n : t);
            t -= r;
            e >>>= 0;
            while (e >= 128) {
                f = e & 127 | 128;
                this.view[t++] = f;
                e >>>= 7;
            }
            this.view[t++] = e;
            if (i) {
                this.offset = t;
                return this;
            }
            return r;
        }, s.writeVarint32ZigZag = function(e, t) {
            return this.writeVarint32(w.zigZagEncode32(e), t);
        }, s.readVarint32 = function(e) {
            var t = typeof e === "undefined";
            if (t) e = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal offset: " + e + " (not an integer)");
                e >>>= 0;
                if (e < 0 || e + 1 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + e + " (+" + 1 + ") <= " + this.buffer.byteLength);
            }
            var i = 0,
                r = 0 >>> 0,
                f;
            do {
                if (!this.noAssert && e > this.limit) {
                    var n = Error("Truncated");
                    n["truncated"] = true;
                    throw n;
                }
                f = this.view[e++];
                if (i < 5) r |= (f & 127) << 7 * i;
                ++i;
            } while ((f & 128) !== 0);
            r |= 0;
            if (t) {
                this.offset = e;
                return r;
            }
            return {
                value: r,
                length: i
            };
        }, s.readVarint32ZigZag = function(e) {
            var t = this.readVarint32(e);
            if (typeof t === "object") t["value"] = w.zigZagDecode32(t["value"]);
            else t = w.zigZagDecode32(t);
            return t;
        }, h) {
        w.MAX_VARINT64_BYTES = 10;
        w.calculateVarint64 = function(e) {
            if (typeof e === "number") e = h.fromNumber(e);
            else if (typeof e === "string") e = h.fromString(e);
            var t = e.toInt() >>> 0,
                i = e.shiftRightUnsigned(28).toInt() >>> 0,
                r = e.shiftRightUnsigned(56).toInt() >>> 0;
            if (r == 0) {
                if (i == 0) {
                    if (t < 1 << 14) return t < 1 << 7 ? 1 : 2;
                    else return t < 1 << 21 ? 3 : 4;
                } else {
                    if (i < 1 << 14) return i < 1 << 7 ? 5 : 6;
                    else return i < 1 << 21 ? 7 : 8;
                }
            } else return r < 1 << 7 ? 9 : 10;
        };
        w.zigZagEncode64 = function(e) {
            if (typeof e === "number") e = h.fromNumber(e, false);
            else if (typeof e === "string") e = h.fromString(e, false);
            else if (e.unsigned !== false) e = e.toSigned();
            return e.shiftLeft(1).xor(e.shiftRight(63)).toUnsigned();
        };
        w.zigZagDecode64 = function(e) {
            if (typeof e === "number") e = h.fromNumber(e, false);
            else if (typeof e === "string") e = h.fromString(e, false);
            else if (e.unsigned !== false) e = e.toSigned();
            return e.shiftRightUnsigned(1).xor(e.and(h.ONE).toSigned().negate()).toSigned();
        };
        s.writeVarint64 = function(e, t) {
            var i = typeof t === "undefined";
            if (i) t = this.offset;
            if (!this.noAssert) {
                if (typeof e === "number") e = h.fromNumber(e);
                else if (typeof e === "string") e = h.fromString(e);
                else if (!(e && e instanceof h)) throw TypeError("Illegal value: " + e + " (not an integer or Long)");
                if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
                t >>>= 0;
                if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
            }
            if (typeof e === "number") e = h.fromNumber(e, false);
            else if (typeof e === "string") e = h.fromString(e, false);
            else if (e.unsigned !== false) e = e.toSigned();
            var r = w.calculateVarint64(e),
                f = e.toInt() >>> 0,
                n = e.shiftRightUnsigned(28).toInt() >>> 0,
                s = e.shiftRightUnsigned(56).toInt() >>> 0;
            t += r;
            var o = this.buffer.byteLength;
            if (t > o) this.resize((o *= 2) > t ? o : t);
            t -= r;
            switch (r) {
                case 10:
                    this.view[t + 9] = s >>> 7 & 1;

                case 9:
                    this.view[t + 8] = r !== 9 ? s | 128 : s & 127;

                case 8:
                    this.view[t + 7] = r !== 8 ? n >>> 21 | 128 : n >>> 21 & 127;

                case 7:
                    this.view[t + 6] = r !== 7 ? n >>> 14 | 128 : n >>> 14 & 127;

                case 6:
                    this.view[t + 5] = r !== 6 ? n >>> 7 | 128 : n >>> 7 & 127;

                case 5:
                    this.view[t + 4] = r !== 5 ? n | 128 : n & 127;

                case 4:
                    this.view[t + 3] = r !== 4 ? f >>> 21 | 128 : f >>> 21 & 127;

                case 3:
                    this.view[t + 2] = r !== 3 ? f >>> 14 | 128 : f >>> 14 & 127;

                case 2:
                    this.view[t + 1] = r !== 2 ? f >>> 7 | 128 : f >>> 7 & 127;

                case 1:
                    this.view[t] = r !== 1 ? f | 128 : f & 127;
            }
            if (i) {
                this.offset += r;
                return this;
            } else {
                return r;
            }
        };
        s.writeVarint64ZigZag = function(e, t) {
            return this.writeVarint64(w.zigZagEncode64(e), t);
        };
        s.readVarint64 = function(e) {
            var t = typeof e === "undefined";
            if (t) e = this.offset;
            if (!this.noAssert) {
                if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal offset: " + e + " (not an integer)");
                e >>>= 0;
                if (e < 0 || e + 1 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + e + " (+" + 1 + ") <= " + this.buffer.byteLength);
            }
            var i = e,
                r = 0,
                f = 0,
                n = 0,
                s = 0;
            s = this.view[e++];
            r = s & 127;
            if (s & 128) {
                s = this.view[e++];
                r |= (s & 127) << 7;
                if (s & 128 || this.noAssert && typeof s === "undefined") {
                    s = this.view[e++];
                    r |= (s & 127) << 14;
                    if (s & 128 || this.noAssert && typeof s === "undefined") {
                        s = this.view[e++];
                        r |= (s & 127) << 21;
                        if (s & 128 || this.noAssert && typeof s === "undefined") {
                            s = this.view[e++];
                            f = s & 127;
                            if (s & 128 || this.noAssert && typeof s === "undefined") {
                                s = this.view[e++];
                                f |= (s & 127) << 7;
                                if (s & 128 || this.noAssert && typeof s === "undefined") {
                                    s = this.view[e++];
                                    f |= (s & 127) << 14;
                                    if (s & 128 || this.noAssert && typeof s === "undefined") {
                                        s = this.view[e++];
                                        f |= (s & 127) << 21;
                                        if (s & 128 || this.noAssert && typeof s === "undefined") {
                                            s = this.view[e++];
                                            n = s & 127;
                                            if (s & 128 || this.noAssert && typeof s === "undefined") {
                                                s = this.view[e++];
                                                n |= (s & 127) << 7;
                                                if (s & 128 || this.noAssert && typeof s === "undefined") {
                                                    throw Error("Buffer overrun");
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            var o = h.fromBits(r | f << 28, f >>> 4 | n << 24, false);
            if (t) {
                this.offset = e;
                return o;
            } else {
                return {
                    value: o,
                    length: e - i
                };
            }
        };
        s.readVarint64ZigZag = function(e) {
            var t = this.readVarint64(e);
            if (t && t["value"] instanceof h) t["value"] = w.zigZagDecode64(t["value"]);
            else t = w.zigZagDecode64(t);
            return t;
        };
    }
    s.writeCString = function(e, t) {
        var i = typeof t === "undefined";
        if (i) t = this.offset;
        var r, f = e.length;
        if (!this.noAssert) {
            if (typeof e !== "string") throw TypeError("Illegal str: Not a string");
            for (r = 0; r < f; ++r) {
                if (e.charCodeAt(r) === 0) throw RangeError("Illegal str: Contains NULL-characters");
            }
            if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
            t >>>= 0;
            if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
        }
        f = u.calculateUTF16asUTF8(o(e))[1];
        t += f + 1;
        var n = this.buffer.byteLength;
        if (t > n) this.resize((n *= 2) > t ? n : t);
        t -= f + 1;
        u.encodeUTF16toUTF8(o(e), function(e) {
            this.view[t++] = e;
        }.bind(this));
        this.view[t++] = 0;
        if (i) {
            this.offset = t;
            return this;
        }
        return f;
    }, s.readCString = function(e) {
        var t = typeof e === "undefined";
        if (t) e = this.offset;
        if (!this.noAssert) {
            if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal offset: " + e + " (not an integer)");
            e >>>= 0;
            if (e < 0 || e + 1 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + e + " (+" + 1 + ") <= " + this.buffer.byteLength);
        }
        var i = e,
            r;
        var f, n = -1;
        u.decodeUTF8toUTF16(function() {
            if (n === 0) return null;
            if (e >= this.limit) throw RangeError("Illegal range: Truncated data, " + e + " < " + this.limit);
            n = this.view[e++];
            return n === 0 ? null : n;
        }.bind(this), f = a(), true);
        if (t) {
            this.offset = e;
            return f();
        } else {
            return {
                string: f(),
                length: e - i
            };
        }
    }, s.writeIString = function(e, t) {
        var i = typeof t === "undefined";
        if (i) t = this.offset;
        if (!this.noAssert) {
            if (typeof e !== "string") throw TypeError("Illegal str: Not a string");
            if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
            t >>>= 0;
            if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
        }
        var r = t,
            f;
        f = u.calculateUTF16asUTF8(o(e), this.noAssert)[1];
        t += 4 + f;
        var n = this.buffer.byteLength;
        if (t > n) this.resize((n *= 2) > t ? n : t);
        t -= 4 + f;
        if (this.littleEndian) {
            this.view[t + 3] = f >>> 24 & 255;
            this.view[t + 2] = f >>> 16 & 255;
            this.view[t + 1] = f >>> 8 & 255;
            this.view[t] = f & 255;
        } else {
            this.view[t] = f >>> 24 & 255;
            this.view[t + 1] = f >>> 16 & 255;
            this.view[t + 2] = f >>> 8 & 255;
            this.view[t + 3] = f & 255;
        }
        t += 4;
        u.encodeUTF16toUTF8(o(e), function(e) {
            this.view[t++] = e;
        }.bind(this));
        if (t !== r + 4 + f) throw RangeError("Illegal range: Truncated data, " + t + " == " + (t + 4 + f));
        if (i) {
            this.offset = t;
            return this;
        }
        return t - r;
    }, s.readIString = function(e) {
        var t = typeof e === "undefined";
        if (t) e = this.offset;
        if (!this.noAssert) {
            if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal offset: " + e + " (not an integer)");
            e >>>= 0;
            if (e < 0 || e + 4 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + e + " (+" + 4 + ") <= " + this.buffer.byteLength);
        }
        var i = e;
        var r = this.readUint32(e);
        var f = this.readUTF8String(r, w.METRICS_BYTES, e += 4);
        e += f["length"];
        if (t) {
            this.offset = e;
            return f["string"];
        } else {
            return {
                string: f["string"],
                length: e - i
            };
        }
    }, w.METRICS_CHARS = "c", w.METRICS_BYTES = "b", s.writeUTF8String = function(e, t) {
        var i = typeof t === "undefined";
        if (i) t = this.offset;
        if (!this.noAssert) {
            if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
            t >>>= 0;
            if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
        }
        var r;
        var f = t;
        r = u.calculateUTF16asUTF8(o(e))[1];
        t += r;
        var n = this.buffer.byteLength;
        if (t > n) this.resize((n *= 2) > t ? n : t);
        t -= r;
        u.encodeUTF16toUTF8(o(e), function(e) {
            this.view[t++] = e;
        }.bind(this));
        if (i) {
            this.offset = t;
            return this;
        }
        return t - f;
    }, s.writeString = s.writeUTF8String, w.calculateUTF8Chars = function(e) {
        return u.calculateUTF16asUTF8(o(e))[0];
    }, w.calculateUTF8Bytes = function(e) {
        return u.calculateUTF16asUTF8(o(e))[1];
    }, w.calculateString = w.calculateUTF8Bytes, s.readUTF8String = function(e, t, i) {
        if (typeof t === "number") {
            i = t;
            t = undefined;
        }
        var r = typeof i === "undefined";
        if (r) i = this.offset;
        if (typeof t === "undefined") t = w.METRICS_CHARS;
        if (!this.noAssert) {
            if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal length: " + e + " (not an integer)");
            e |= 0;
            if (typeof i !== "number" || i % 1 !== 0) throw TypeError("Illegal offset: " + i + " (not an integer)");
            i >>>= 0;
            if (i < 0 || i + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + i + " (+" + 0 + ") <= " + this.buffer.byteLength);
        }
        var f = 0,
            n = i,
            s;
        if (t === w.METRICS_CHARS) {
            s = a();
            u.decodeUTF8(function() {
                return f < e && i < this.limit ? this.view[i++] : null;
            }.bind(this), function(e) {
                ++f;
                u.UTF8toUTF16(e, s);
            });
            if (f !== e) throw RangeError("Illegal range: Truncated data, " + f + " == " + e);
            if (r) {
                this.offset = i;
                return s();
            } else {
                return {
                    string: s(),
                    length: i - n
                };
            }
        } else if (t === w.METRICS_BYTES) {
            if (!this.noAssert) {
                if (typeof i !== "number" || i % 1 !== 0) throw TypeError("Illegal offset: " + i + " (not an integer)");
                i >>>= 0;
                if (i < 0 || i + e > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + i + " (+" + e + ") <= " + this.buffer.byteLength);
            }
            var o = i + e;
            u.decodeUTF8toUTF16(function() {
                return i < o ? this.view[i++] : null;
            }.bind(this), s = a(), this.noAssert);
            if (i !== o) throw RangeError("Illegal range: Truncated data, " + i + " == " + o);
            if (r) {
                this.offset = i;
                return s();
            } else {
                return {
                    string: s(),
                    length: i - n
                };
            }
        } else throw TypeError("Unsupported metrics: " + t);
    }, s.readString = s.readUTF8String, s.writeVString = function(e, t) {
        var i = typeof t === "undefined";
        if (i) t = this.offset;
        if (!this.noAssert) {
            if (typeof e !== "string") throw TypeError("Illegal str: Not a string");
            if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: " + t + " (not an integer)");
            t >>>= 0;
            if (t < 0 || t + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + t + " (+" + 0 + ") <= " + this.buffer.byteLength);
        }
        var r = t,
            f, n;
        f = u.calculateUTF16asUTF8(o(e), this.noAssert)[1];
        n = w.calculateVarint32(f);
        t += n + f;
        var s = this.buffer.byteLength;
        if (t > s) this.resize((s *= 2) > t ? s : t);
        t -= n + f;
        t += this.writeVarint32(f, t);
        u.encodeUTF16toUTF8(o(e), function(e) {
            this.view[t++] = e;
        }.bind(this));
        if (t !== r + f + n) throw RangeError("Illegal range: Truncated data, " + t + " == " + (t + f + n));
        if (i) {
            this.offset = t;
            return this;
        }
        return t - r;
    }, s.readVString = function(e) {
        var t = typeof e === "undefined";
        if (t) e = this.offset;
        if (!this.noAssert) {
            if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal offset: " + e + " (not an integer)");
            e >>>= 0;
            if (e < 0 || e + 1 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + e + " (+" + 1 + ") <= " + this.buffer.byteLength);
        }
        var i = e;
        var r = this.readVarint32(e);
        var f = this.readUTF8String(r["value"], w.METRICS_BYTES, e += r["length"]);
        e += f["length"];
        if (t) {
            this.offset = e;
            return f["string"];
        } else {
            return {
                string: f["string"],
                length: e - i
            };
        }
    }, s.append = function(e, t, i) {
        if (typeof t === "number" || typeof t !== "string") {
            i = t;
            t = undefined;
        }
        var r = typeof i === "undefined";
        if (r) i = this.offset;
        if (!this.noAssert) {
            if (typeof i !== "number" || i % 1 !== 0) throw TypeError("Illegal offset: " + i + " (not an integer)");
            i >>>= 0;
            if (i < 0 || i + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + i + " (+" + 0 + ") <= " + this.buffer.byteLength);
        }
        if (!(e instanceof w)) e = w.wrap(e, t);
        var f = e.limit - e.offset;
        if (f <= 0) return this;
        i += f;
        var n = this.buffer.byteLength;
        if (i > n) this.resize((n *= 2) > i ? n : i);
        i -= f;
        this.view.set(e.view.subarray(e.offset, e.limit), i);
        e.offset += f;
        if (r) this.offset += f;
        return this;
    }, s.appendTo = function(e, t) {
        e.append(this, t);
        return this;
    }, s.writeBytes = s.append, s.assert = function(e) {
        this.noAssert = !e;
        return this;
    }, s.capacity = function() {
        return this.buffer.byteLength;
    }, s.clear = function() {
        this.offset = 0;
        this.limit = this.buffer.byteLength;
        this.markedOffset = -1;
        return this;
    }, s.clone = function(e) {
        var t = new w(0, this.littleEndian, this.noAssert);
        if (e) {
            t.buffer = new ArrayBuffer(this.buffer.byteLength);
            t.view = new Uint8Array(t.buffer);
        } else {
            t.buffer = this.buffer;
            t.view = this.view;
        }
        t.offset = this.offset;
        t.markedOffset = this.markedOffset;
        t.limit = this.limit;
        return t;
    }, s.compact = function(e, t) {
        if (typeof e === "undefined") e = this.offset;
        if (typeof t === "undefined") t = this.limit;
        if (!this.noAssert) {
            if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal begin: Not an integer");
            e >>>= 0;
            if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal end: Not an integer");
            t >>>= 0;
            if (e < 0 || e > t || t > this.buffer.byteLength) throw RangeError("Illegal range: 0 <= " + e + " <= " + t + " <= " + this.buffer.byteLength);
        }
        if (e === 0 && t === this.buffer.byteLength) return this;
        var i = t - e;
        if (i === 0) {
            this.buffer = n;
            this.view = null;
            if (this.markedOffset >= 0) this.markedOffset -= e;
            this.offset = 0;
            this.limit = 0;
            return this;
        }
        var r = new ArrayBuffer(i);
        var f = new Uint8Array(r);
        f.set(this.view.subarray(e, t));
        this.buffer = r;
        this.view = f;
        if (this.markedOffset >= 0) this.markedOffset -= e;
        this.offset = 0;
        this.limit = i;
        return this;
    }, s.copy = function(e, t) {
        if (typeof e === "undefined") e = this.offset;
        if (typeof t === "undefined") t = this.limit;
        if (!this.noAssert) {
            if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal begin: Not an integer");
            e >>>= 0;
            if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal end: Not an integer");
            t >>>= 0;
            if (e < 0 || e > t || t > this.buffer.byteLength) throw RangeError("Illegal range: 0 <= " + e + " <= " + t + " <= " + this.buffer.byteLength);
        }
        if (e === t) return new w(0, this.littleEndian, this.noAssert);
        var i = t - e,
            r = new w(i, this.littleEndian, this.noAssert);
        r.offset = 0;
        r.limit = i;
        if (r.markedOffset >= 0) r.markedOffset -= e;
        this.copyTo(r, 0, e, t);
        return r;
    }, s.copyTo = function(e, t, i, r) {
        var f, n;
        if (!this.noAssert) {
            if (!w.isByteBuffer(e)) throw TypeError("Illegal target: Not a ByteBuffer");
        }
        t = (n = typeof t === "undefined") ? e.offset : t | 0;
        i = (f = typeof i === "undefined") ? this.offset : i | 0;
        r = typeof r === "undefined" ? this.limit : r | 0;
        if (t < 0 || t > e.buffer.byteLength) throw RangeError("Illegal target range: 0 <= " + t + " <= " + e.buffer.byteLength);
        if (i < 0 || r > this.buffer.byteLength) throw RangeError("Illegal source range: 0 <= " + i + " <= " + this.buffer.byteLength);
        var s = r - i;
        if (s === 0) return e;
        e.ensureCapacity(t + s);
        e.view.set(this.view.subarray(i, r), t);
        if (f) this.offset += s;
        if (n) e.offset += s;
        return this;
    }, s.ensureCapacity = function(e) {
        var t = this.buffer.byteLength;
        if (t < e) return this.resize((t *= 2) > e ? t : e);
        return this;
    }, s.fill = function(e, t, i) {
        var r = typeof t === "undefined";
        if (r) t = this.offset;
        if (typeof e === "string" && e.length > 0) e = e.charCodeAt(0);
        if (typeof t === "undefined") t = this.offset;
        if (typeof i === "undefined") i = this.limit;
        if (!this.noAssert) {
            if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal value: " + e + " (not an integer)");
            e |= 0;
            if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal begin: Not an integer");
            t >>>= 0;
            if (typeof i !== "number" || i % 1 !== 0) throw TypeError("Illegal end: Not an integer");
            i >>>= 0;
            if (t < 0 || t > i || i > this.buffer.byteLength) throw RangeError("Illegal range: 0 <= " + t + " <= " + i + " <= " + this.buffer.byteLength);
        }
        if (t >= i) return this;
        while (t < i) this.view[t++] = e;
        if (r) this.offset = t;
        return this;
    }, s.flip = function() {
        this.limit = this.offset;
        this.offset = 0;
        return this;
    }, s.mark = function(e) {
        e = typeof e === "undefined" ? this.offset : e;
        if (!this.noAssert) {
            if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal offset: " + e + " (not an integer)");
            e >>>= 0;
            if (e < 0 || e + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + e + " (+" + 0 + ") <= " + this.buffer.byteLength);
        }
        this.markedOffset = e;
        return this;
    }, s.order = function(e) {
        if (!this.noAssert) {
            if (typeof e !== "boolean") throw TypeError("Illegal littleEndian: Not a boolean");
        }
        this.littleEndian = !!e;
        return this;
    }, s.LE = function(e) {
        this.littleEndian = typeof e !== "undefined" ? !!e : true;
        return this;
    }, s.BE = function(e) {
        this.littleEndian = typeof e !== "undefined" ? !e : false;
        return this;
    }, s.prepend = function(e, t, i) {
        if (typeof t === "number" || typeof t !== "string") {
            i = t;
            t = undefined;
        }
        var r = typeof i === "undefined";
        if (r) i = this.offset;
        if (!this.noAssert) {
            if (typeof i !== "number" || i % 1 !== 0) throw TypeError("Illegal offset: " + i + " (not an integer)");
            i >>>= 0;
            if (i < 0 || i + 0 > this.buffer.byteLength) throw RangeError("Illegal offset: 0 <= " + i + " (+" + 0 + ") <= " + this.buffer.byteLength);
        }
        if (!(e instanceof w)) e = w.wrap(e, t);
        var f = e.limit - e.offset;
        if (f <= 0) return this;
        var n = f - i;
        if (n > 0) {
            var s = new ArrayBuffer(this.buffer.byteLength + n);
            var o = new Uint8Array(s);
            o.set(this.view.subarray(i, this.buffer.byteLength), f);
            this.buffer = s;
            this.view = o;
            this.offset += n;
            if (this.markedOffset >= 0) this.markedOffset += n;
            this.limit += n;
            i += n;
        } else {
            var h = new Uint8Array(this.buffer);
        }
        this.view.set(e.view.subarray(e.offset, e.limit), i - f);
        e.offset = e.limit;
        if (r) this.offset -= f;
        return this;
    }, s.prependTo = function(e, t) {
        e.prepend(this, t);
        return this;
    }, s.printDebug = function(e) {
        if (typeof e !== "function") e = console.log.bind(console);
        e(this.toString() + "\n" + "-------------------------------------------------------------------\n" + this.toDebug(true));
    }, s.remaining = function() {
        return this.limit - this.offset;
    }, s.reset = function() {
        if (this.markedOffset >= 0) {
            this.offset = this.markedOffset;
            this.markedOffset = -1;
        } else {
            this.offset = 0;
        }
        return this;
    }, s.resize = function(e) {
        if (!this.noAssert) {
            if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal capacity: " + e + " (not an integer)");
            e |= 0;
            if (e < 0) throw RangeError("Illegal capacity: 0 <= " + e);
        }
        if (this.buffer.byteLength < e) {
            var t = new ArrayBuffer(e);
            var i = new Uint8Array(t);
            i.set(this.view);
            this.buffer = t;
            this.view = i;
        }
        return this;
    }, s.reverse = function(e, t) {
        if (typeof e === "undefined") e = this.offset;
        if (typeof t === "undefined") t = this.limit;
        if (!this.noAssert) {
            if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal begin: Not an integer");
            e >>>= 0;
            if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal end: Not an integer");
            t >>>= 0;
            if (e < 0 || e > t || t > this.buffer.byteLength) throw RangeError("Illegal range: 0 <= " + e + " <= " + t + " <= " + this.buffer.byteLength);
        }
        if (e === t) return this;
        Array.prototype.reverse.call(this.view.subarray(e, t));
        return this;
    }, s.skip = function(e) {
        if (!this.noAssert) {
            if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal length: " + e + " (not an integer)");
            e |= 0;
        }
        var t = this.offset + e;
        if (!this.noAssert) {
            if (t < 0 || t > this.buffer.byteLength) throw RangeError("Illegal length: 0 <= " + this.offset + " + " + e + " <= " + this.buffer.byteLength);
        }
        this.offset = t;
        return this;
    }, s.slice = function(e, t) {
        if (typeof e === "undefined") e = this.offset;
        if (typeof t === "undefined") t = this.limit;
        if (!this.noAssert) {
            if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal begin: Not an integer");
            e >>>= 0;
            if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal end: Not an integer");
            t >>>= 0;
            if (e < 0 || e > t || t > this.buffer.byteLength) throw RangeError("Illegal range: 0 <= " + e + " <= " + t + " <= " + this.buffer.byteLength);
        }
        var i = this.clone();
        i.offset = e;
        i.limit = t;
        return i;
    }, s.toBuffer = function(e) {
        var t = this.offset,
            i = this.limit;
        if (!this.noAssert) {
            if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal offset: Not an integer");
            t >>>= 0;
            if (typeof i !== "number" || i % 1 !== 0) throw TypeError("Illegal limit: Not an integer");
            i >>>= 0;
            if (t < 0 || t > i || i > this.buffer.byteLength) throw RangeError("Illegal range: 0 <= " + t + " <= " + i + " <= " + this.buffer.byteLength);
        }
        if (!e && t === 0 && i === this.buffer.byteLength) return this.buffer;
        if (t === i) return n;
        var r = new ArrayBuffer(i - t);
        new Uint8Array(r).set(new Uint8Array(this.buffer).subarray(t, i), 0);
        return r;
    }, s.toArrayBuffer = s.toBuffer, s.toString = function(e, t, i) {
        if (typeof e === "undefined") return "ByteBufferAB(offset=" + this.offset + ",markedOffset=" + this.markedOffset + ",limit=" + this.limit + ",capacity=" + this.capacity() + ")";
        if (typeof e === "number") e = "utf8", t = e, i = t;
        switch (e) {
            case "utf8":
                return this.toUTF8(t, i);

            case "base64":
                return this.toBase64(t, i);

            case "hex":
                return this.toHex(t, i);

            case "binary":
                return this.toBinary(t, i);

            case "debug":
                return this.toDebug();

            case "columns":
                return this.toColumns();

            default:
                throw Error("Unsupported encoding: " + e);
        }
    };
    var l = function() {
        "use strict";
        var e = {};
        var f = [65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 43, 47];
        var s = [];
        for (var t = 0, i = f.length; t < i; ++t) s[f[t]] = t;
        e.encode = function(e, t) {
            var i, r;
            while ((i = e()) !== null) {
                t(f[i >> 2 & 63]);
                r = (i & 3) << 4;
                if ((i = e()) !== null) {
                    r |= i >> 4 & 15;
                    t(f[(r | i >> 4 & 15) & 63]);
                    r = (i & 15) << 2;
                    if ((i = e()) !== null) t(f[(r | i >> 6 & 3) & 63]), t(f[i & 63]);
                    else t(f[r & 63]),
                        t(61);
                } else t(f[r & 63]), t(61), t(61);
            }
        };
        e.decode = function(e, t) {
            var i, r, f;

            function n(e) {
                throw Error("Illegal character code: " + e);
            }
            while ((i = e()) !== null) {
                r = s[i];
                if (typeof r === "undefined") n(i);
                if ((i = e()) !== null) {
                    f = s[i];
                    if (typeof f === "undefined") n(i);
                    t(r << 2 >>> 0 | (f & 48) >> 4);
                    if ((i = e()) !== null) {
                        r = s[i];
                        if (typeof r === "undefined")
                            if (i === 61) break;
                            else n(i);
                        t((f & 15) << 4 >>> 0 | (r & 60) >> 2);
                        if ((i = e()) !== null) {
                            f = s[i];
                            if (typeof f === "undefined")
                                if (i === 61) break;
                                else n(i);
                            t((r & 3) << 6 >>> 0 | f);
                        }
                    }
                }
            }
        };
        e.test = function(e) {
            return /^(?:[A-Za-z0-9+/]{4})*(?:[A-Za-z0-9+/]{2}==|[A-Za-z0-9+/]{3}=)?$/.test(e);
        };
        return e;
    }();
    s.toBase64 = function(e, t) {
        if (typeof e === "undefined") e = this.offset;
        if (typeof t === "undefined") t = this.limit;
        e = e | 0;
        t = t | 0;
        if (e < 0 || t > this.capacity || e > t) throw RangeError("begin, end");
        var i;
        l.encode(function() {
            return e < t ? this.view[e++] : null;
        }.bind(this), i = a());
        return i();
    }, w.fromBase64 = function(e, t) {
        if (typeof e !== "string") throw TypeError("str");
        var i = new w(e.length / 4 * 3, t),
            r = 0;
        l.decode(o(e), function(e) {
            i.view[r++] = e;
        });
        i.limit = r;
        return i;
    }, w.btoa = function(e) {
        return w.fromBinary(e).toBase64();
    }, w.atob = function(e) {
        return w.fromBase64(e).toBinary();
    }, s.toBinary = function(e, t) {
        if (typeof e === "undefined") e = this.offset;
        if (typeof t === "undefined") t = this.limit;
        e |= 0;
        t |= 0;
        if (e < 0 || t > this.capacity() || e > t) throw RangeError("begin, end");
        if (e === t) return "";
        var i = [],
            r = [];
        while (e < t) {
            i.push(this.view[e++]);
            if (i.length >= 1024) r.push(String.fromCharCode.apply(String, i)), i = [];
        }
        return r.join("") + String.fromCharCode.apply(String, i);
    }, w.fromBinary = function(e, t) {
        if (typeof e !== "string") throw TypeError("str");
        var i = 0,
            r = e.length,
            f, n = new w(r, t);
        while (i < r) {
            f = e.charCodeAt(i);
            if (f > 255) throw RangeError("illegal char code: " + f);
            n.view[i++] = f;
        }
        n.limit = r;
        return n;
    }, s.toDebug = function(e) {
        var t = -1,
            i = this.buffer.byteLength,
            r, f = "",
            n = "",
            s = "";
        while (t < i) {
            if (t !== -1) {
                r = this.view[t];
                if (r < 16) f += "0" + r.toString(16).toUpperCase();
                else f += r.toString(16).toUpperCase();
                if (e) n += r > 32 && r < 127 ? String.fromCharCode(r) : ".";
            }
            ++t;
            if (e) {
                if (t > 0 && t % 16 === 0 && t !== i) {
                    while (f.length < 3 * 16 + 3) f += " ";
                    s += f + n + "\n";
                    f = n = "";
                }
            }
            if (t === this.offset && t === this.limit) f += t === this.markedOffset ? "!" : "|";
            else if (t === this.offset) f += t === this.markedOffset ? "[" : "<";
            else if (t === this.limit) f += t === this.markedOffset ? "]" : ">";
            else f += t === this.markedOffset ? "'" : e || t !== 0 && t !== i ? " " : "";
        }
        if (e && f !== " ") {
            while (f.length < 3 * 16 + 3) f += " ";
            s += f + n + "\n";
        }
        return e ? s : f;
    }, w.fromDebug = function(e, t, i) {
        var r = e.length,
            f = new w((r + 1) / 3 | 0, t, i);
        var n = 0,
            s = 0,
            o, h, a = false,
            l = false,
            u = false,
            g = false,
            y = false;
        while (n < r) {
            switch (o = e.charAt(n++)) {
                case "!":
                    if (!i) {
                        if (l || u || g) {
                            y = true;
                            break;
                        }
                        l = u = g = true;
                    }
                    f.offset = f.markedOffset = f.limit = s;
                    a = false;
                    break;

                case "|":
                    if (!i) {
                        if (l || g) {
                            y = true;
                            break;
                        }
                        l = g = true;
                    }
                    f.offset = f.limit = s;
                    a = false;
                    break;

                case "[":
                    if (!i) {
                        if (l || u) {
                            y = true;
                            break;
                        }
                        l = u = true;
                    }
                    f.offset = f.markedOffset = s;
                    a = false;
                    break;

                case "<":
                    if (!i) {
                        if (l) {
                            y = true;
                            break;
                        }
                        l = true;
                    }
                    f.offset = s;
                    a = false;
                    break;

                case "]":
                    if (!i) {
                        if (g || u) {
                            y = true;
                            break;
                        }
                        g = u = true;
                    }
                    f.limit = f.markedOffset = s;
                    a = false;
                    break;

                case ">":
                    if (!i) {
                        if (g) {
                            y = true;
                            break;
                        }
                        g = true;
                    }
                    f.limit = s;
                    a = false;
                    break;

                case "'":
                    if (!i) {
                        if (u) {
                            y = true;
                            break;
                        }
                        u = true;
                    }
                    f.markedOffset = s;
                    a = false;
                    break;

                case " ":
                    a = false;
                    break;

                default:
                    if (!i) {
                        if (a) {
                            y = true;
                            break;
                        }
                    }
                    h = parseInt(o + e.charAt(n++), 16);
                    if (!i) {
                        if (isNaN(h) || h < 0 || h > 255) throw TypeError("Illegal str: Not a debug encoded string");
                    }
                    f.view[s++] = h;
                    a = true;
            }
            if (y) throw TypeError("Illegal str: Invalid symbol at " + n);
        }
        if (!i) {
            if (!l || !g) throw TypeError("Illegal str: Missing offset or limit");
            if (s < f.buffer.byteLength) throw TypeError("Illegal str: Not a debug encoded string (is it hex?) " + s + " < " + r);
        }
        return f;
    }, s.toHex = function(e, t) {
        e = typeof e === "undefined" ? this.offset : e;
        t = typeof t === "undefined" ? this.limit : t;
        if (!this.noAssert) {
            if (typeof e !== "number" || e % 1 !== 0) throw TypeError("Illegal begin: Not an integer");
            e >>>= 0;
            if (typeof t !== "number" || t % 1 !== 0) throw TypeError("Illegal end: Not an integer");
            t >>>= 0;
            if (e < 0 || e > t || t > this.buffer.byteLength) throw RangeError("Illegal range: 0 <= " + e + " <= " + t + " <= " + this.buffer.byteLength);
        }
        var i = new Array(t - e),
            r;
        while (e < t) {
            r = this.view[e++];
            if (r < 16) i.push("0", r.toString(16));
            else i.push(r.toString(16));
        }
        return i.join("");
    }, w.fromHex = function(e, t, i) {
        if (!i) {
            if (typeof e !== "string") throw TypeError("Illegal str: Not a string");
            if (e.length % 2 !== 0) throw TypeError("Illegal str: Length not a multiple of 2");
        }
        var r = e.length,
            f = new w(r / 2 | 0, t),
            n;
        for (var s = 0, o = 0; s < r; s += 2) {
            n = parseInt(e.substring(s, s + 2), 16);
            if (!i)
                if (!isFinite(n) || n < 0 || n > 255) throw TypeError("Illegal str: Contains non-hex characters");
            f.view[o++] = n;
        }
        f.limit = o;
        return f;
    };
    var u = function() {
        "use strict";
        var r = {};
        r.MAX_CODEPOINT = 1114111;
        r.encodeUTF8 = function(e, t) {
            var i = null;
            if (typeof e === "number") i = e, e = function() {
                return null;
            };
            while (i !== null || (i = e()) !== null) {
                if (i < 128) t(i & 127);
                else if (i < 2048) t(i >> 6 & 31 | 192), t(i & 63 | 128);
                else if (i < 65536) t(i >> 12 & 15 | 224),
                    t(i >> 6 & 63 | 128), t(i & 63 | 128);
                else t(i >> 18 & 7 | 240), t(i >> 12 & 63 | 128),
                    t(i >> 6 & 63 | 128), t(i & 63 | 128);
                i = null;
            }
        };
        r.decodeUTF8 = function(e, t) {
            var i, r, f, n, s = function(e) {
                e = e.slice(0, e.indexOf(null));
                var t = Error(e.toString());
                t.name = "TruncatedError";
                t["bytes"] = e;
                throw t;
            };
            while ((i = e()) !== null) {
                if ((i & 128) === 0) t(i);
                else if ((i & 224) === 192)(r = e()) === null && s([i, r]),
                    t((i & 31) << 6 | r & 63);
                else if ((i & 240) === 224)((r = e()) === null || (f = e()) === null) && s([i, r, f]),
                    t((i & 15) << 12 | (r & 63) << 6 | f & 63);
                else if ((i & 248) === 240)((r = e()) === null || (f = e()) === null || (n = e()) === null) && s([i, r, f, n]),
                    t((i & 7) << 18 | (r & 63) << 12 | (f & 63) << 6 | n & 63);
                else throw RangeError("Illegal starting byte: " + i);
            }
        };
        r.UTF16toUTF8 = function(e, t) {
            var i, r = null;
            while (true) {
                if ((i = r !== null ? r : e()) === null) break;
                if (i >= 55296 && i <= 57343) {
                    if ((r = e()) !== null) {
                        if (r >= 56320 && r <= 57343) {
                            t((i - 55296) * 1024 + r - 56320 + 65536);
                            r = null;
                            continue;
                        }
                    }
                }
                t(i);
            }
            if (r !== null) t(r);
        };
        r.UTF8toUTF16 = function(e, t) {
            var i = null;
            if (typeof e === "number") i = e, e = function() {
                return null;
            };
            while (i !== null || (i = e()) !== null) {
                if (i <= 65535) t(i);
                else i -= 65536, t((i >> 10) + 55296), t(i % 1024 + 56320);
                i = null;
            }
        };
        r.encodeUTF16toUTF8 = function(e, t) {
            r.UTF16toUTF8(e, function(e) {
                r.encodeUTF8(e, t);
            });
        };
        r.decodeUTF8toUTF16 = function(e, t) {
            r.decodeUTF8(e, function(e) {
                r.UTF8toUTF16(e, t);
            });
        };
        r.calculateCodePoint = function(e) {
            return e < 128 ? 1 : e < 2048 ? 2 : e < 65536 ? 3 : 4;
        };
        r.calculateUTF8 = function(e) {
            var t, i = 0;
            while ((t = e()) !== null) i += t < 128 ? 1 : t < 2048 ? 2 : t < 65536 ? 3 : 4;
            return i;
        };
        r.calculateUTF16asUTF8 = function(e) {
            var t = 0,
                i = 0;
            r.UTF16toUTF8(e, function(e) {
                ++t;
                i += e < 128 ? 1 : e < 2048 ? 2 : e < 65536 ? 3 : 4;
            });
            return [t, i];
        };
        return r;
    }();
    return s.toUTF8 = function(e, t) {
        if (void 0 === e && (e = this.offset), void 0 === t && (t = this.limit), !this.noAssert) {
            if ("number" != typeof e || e % 1 != 0) throw TypeError("Illegal begin: Not an integer");
            if (e >>>= 0, "number" != typeof t || t % 1 != 0) throw TypeError("Illegal end: Not an integer");
            if (t >>>= 0, e < 0 || t < e || t > this.buffer.byteLength) throw RangeError("Illegal range: 0 <= " + e + " <= " + t + " <= " + this.buffer.byteLength);
        }
        var i;
        try {
            u.decodeUTF8toUTF16(function() {
                return e < t ? this.view[e++] : null;
            }.bind(this), i = a());
        } catch (r) {
            if (e !== t) throw RangeError("Illegal range: Truncated data, " + e + " != " + t);
        }
        return i();
    }, w.fromUTF8 = function(e, t, i) {
        if (!i && "string" != typeof e) throw TypeError("Illegal str: Not a string");
        var r = new w(u.calculateUTF16asUTF8(o(e), !0)[1], t, i),
            f = 0;
        return u.encodeUTF16toUTF8(o(e), function(e) {
            r.view[f++] = e;
        }), r.limit = f, r;
    }, w;
}(window.Long);